import Log, { Logger } from "@rbxts/log"
import { start } from "ReplicatedStorage/ecs"
import { serverState } from "ReplicatedStorage/ecs/state"
import { Host } from "ReplicatedStorage/hosts"
import { setEnvironment } from "ReplicatedStorage/idAttribute"
import { getEvent } from "ReplicatedStorage/remotes"

const HOST = Host.Server

const serverLogger = Logger.configure()
    .EnrichWithProperty("Roblox-TS Version", _VERSION)
    .WriteTo(Log.RobloxOutput())
    .Create()

const ServerState = new serverState(
    serverLogger
)

// We only do this here at the moment to create a dummy event for replication.
// In the future this will be created by the replication system.
getEvent("EcsReplication")

setEnvironment(HOST)
start(HOST, ServerState)